<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.bonusgroupaccount_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="isDefault", slot-scope="{row}">
        <el-tag v-if="row.isDefault === 1" type="success">平台账户</el-tag>
        <el-tag v-if="row.isDefault === 0" type="primary">商户账户</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bonus/bonusgroupaccount";
  import {mapGetters} from "vuex";

  export default {
    data() {
      var validateRate = (rule, value, callback)=>{
        if (value === '') {
          callback(new Error('请输入分润比例'));
        } else {
          let pattern = /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/;
          if(pattern.test(value)){
            callback();
          }else{
            callback(new Error('请正确填写分润比例,可保留两位小数'));
          }
          callback();
        }
      };
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "业务场景",
              prop: "bonusSceneId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bonus-scene/bonusscene/listBonusScene?size=10",
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: false,
                message: "请选择业务场景",
                trigger: "blur",
              }]
            },
            {
              label: "分润商户",
              prop: "bonusGroupId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bonus-group/bonusgroup/listBonusGroup?size=500",
              props:{
                label: "name",
                value: "id"
              },
              rules: [{
                required: false,
                message: "请选择分润商户",
                trigger: "blur",
              }]
            },
            {
              label: "收款账户名",
              prop: "accountReceiverName",
              labelWidth: 100,
              rules: [{
                required: true,
                message: "请输入收款账户名称",
                trigger: "blur"
              }]
            },
            {
              label: "收款账户号码",
              prop: "receiverAccountNo",
              labelWidth: 110,
              rules: [{
                required: true,
                message: "请输入收款账户号码",
                trigger: "blur"
              }]
            },
            {
              label: "开户行",
              prop: "receiverBankCode",
              labelWidth: 110,
              type: "select",
              dicUrl: "/api/cyzh-guosen/bankcode/listBankCode?name={{key}}",
              props:{
                label: "name",
                value: "code"
              },
              hide: true,
              remote:true,
              filterable: true,
              placeholder:"输入关键字可搜索",
              rules: [{
                required: true,
                message: "请输入开户总行编码",
                trigger: "blur"
              }]
            },
            {
              label: "账户类型",
              prop: "bankAccountType",
              type: "select",
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=bank_account_type",
              props:{
                label: "dictValue",
                value: "dictKey"
              },
              rules: [{
                required: true,
                message: "请输入分润比例",
                trigger: "blur"
              }]
            },
            {
              label: "分润比例(%)",
              prop: "rate",
              labelWidth: 110,
              rules: [{
                required: true,
                trigger: "blur",
                validator: validateRate
              }]
            },
            {
              label: "是否平台账户",
              prop: "isDefault",
              labelWidth: 110,
              type: "select",
              dicData:[
                {
                  label:"否",
                  value:0
                },
                {
                  label:"是",
                  value: 1
                },
              ],
              slot: true,
              rules: [{
                required: true,
                trigger: "blur",
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bonusgroupaccount_add, false),
          viewBtn: this.vaildData(this.permission.bonusgroupaccount_view, false),
          delBtn: this.vaildData(this.permission.bonusgroupaccount_delete, false),
          editBtn: this.vaildData(this.permission.bonusgroupaccount_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        if(row.isDefault === 0){
          if(row.bonusSceneId == null){
            this.$message({
              type: "error",
              message: "非平台账户必须选择业务场景和归属商户"
            });
            return ;
          }
        }
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        if(row.isDefault === 0){
          if(row.bonusSceneId == null){
            this.$message({
              type: "error",
              message: "非平台账户必须选择业务场景和归属商户"
            });
            return ;
          }
        }
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
